diff --git a/include/compiz-core.h b/include/compiz-core.h
index 38257e6..e649d19 100644
--- a/include/compiz-core.h
+++ b/include/compiz-core.h
@@ -2523,579 +3200,6 @@ setWindowPaintOffset (CompScreen *s,
 		      int        y);
 
 
-/* window.c */
-
-#define WINDOW_INVISIBLE(w)				       \
-    ((w)->attrib.map_state != IsViewable		    || \
-     (!(w)->damaged)					    || \
-     (w)->attrib.x + (w)->width  + (w)->output.right  <= 0  || \
-     (w)->attrib.y + (w)->height + (w)->output.bottom <= 0  || \
-     (w)->attrib.x - (w)->output.left >= (w)->screen->width || \
-     (w)->attrib.y - (w)->output.top >= (w)->screen->height)
-
-typedef enum {
-    CompStackingUpdateModeNone = 0,
-    CompStackingUpdateModeNormal,
-    CompStackingUpdateModeAboveFullscreen,
-    CompStackingUpdateModeInitialMap,
-    CompStackingUpdateModeInitialMapDeniedFocus
-} CompStackingUpdateMode;
-
-struct _CompWindowExtents {
-    int left;
-    int right;
-    int top;
-    int bottom;
-};
-
-typedef struct _CompStruts {
-    XRectangle left;
-    XRectangle right;
-    XRectangle top;
-    XRectangle bottom;
-} CompStruts;
-
-struct _CompWindow {
-    CompObject base;
-
-    CompScreen *screen;
-    CompWindow *next;
-    CompWindow *prev;
-
-    int		      refcnt;
-    Window	      id;
-    Window	      frame;
-    unsigned int      mapNum;
-    unsigned int      activeNum;
-    XWindowAttributes attrib;
-    int		      serverX;
-    int		      serverY;
-    int		      serverWidth;
-    int		      serverHeight;
-    int		      serverBorderWidth;
-    Window	      transientFor;
-    Window	      clientLeader;
-    XSizeHints	      sizeHints;
-    Pixmap	      pixmap;
-    CompTexture       *texture;
-    CompMatrix        matrix;
-    Damage	      damage;
-    Bool	      inputHint;
-    Bool	      alpha;
-    GLint	      width;
-    GLint	      height;
-    Region	      region;
-    Region	      clip;
-    unsigned int      wmType;
-    unsigned int      type;
-    unsigned int      state;
-    unsigned int      actions;
-    unsigned int      protocols;
-    unsigned int      mwmDecor;
-    unsigned int      mwmFunc;
-    Bool	      invisible;
-    Bool	      destroyed;
-    Bool	      damaged;
-    Bool	      redirected;
-    Bool	      managed;
-    Bool	      bindFailed;
-    Bool	      overlayWindow;
-    int		      destroyRefCnt;
-    int		      unmapRefCnt;
-
-    unsigned int initialViewportX;
-    unsigned int initialViewportY;
-
-    Time initialTimestamp;
-    Bool initialTimestampSet;
-
-    Bool placed;
-    Bool minimized;
-    Bool inShowDesktopMode;
-    Bool shaded;
-    Bool hidden;
-    Bool grabbed;
-
-    unsigned int desktop;
-
-    int pendingUnmaps;
-    int pendingMaps;
-
-    char *startupId;
-    char *resName;
-    char *resClass;
-
-    CompGroup *group;
-
-    unsigned int lastPong;
-    Bool	 alive;
-
-    WindowPaintAttrib paint;
-    WindowPaintAttrib lastPaint;
-
-    unsigned int lastMask;
-
-    CompWindowExtents input;
-    CompWindowExtents output;
-
-    CompStruts *struts;
-
-    CompIcon **icon;
-    int	     nIcon;
-
-    XRectangle iconGeometry;
-    Bool       iconGeometrySet;
-
-    XWindowChanges saveWc;
-    int		   saveMask;
-
-    XSyncCounter  syncCounter;
-    XSyncValue	  syncValue;
-    XSyncAlarm	  syncAlarm;
-    unsigned long syncAlarmConnection;
-    unsigned int  syncWaitHandle;
-
-    Bool syncWait;
-    int	 syncX;
-    int	 syncY;
-    int	 syncWidth;
-    int	 syncHeight;
-    int	 syncBorderWidth;
-
-    Bool closeRequests;
-    Time lastCloseRequestTime;
-
-    XRectangle *damageRects;
-    int	       sizeDamage;
-    int	       nDamage;
-
-    GLfloat  *vertices;
-    int      vertexSize;
-    int      vertexStride;
-    GLushort *indices;
-    int      indexSize;
-    int      vCount;
-    int      texUnits;
-    int      texCoordSize;
-    int      indexCount;
-
-    /* must be set by addWindowGeometry */
-    DrawWindowGeometryProc drawWindowGeometry;
-};
-
-#define GET_CORE_WINDOW(object) ((CompWindow *) (object))
-#define CORE_WINDOW(object) CompWindow *w = GET_CORE_WINDOW (object)
-
-CompBool
-allocWindowObjectPrivates (CompObject *object,
-			   CompObject *parent);
-
-int
-allocWindowObjectPrivateIndex (CompObject *parent);
-
-void
-freeWindowObjectPrivateIndex (CompObject *parent,
-			      int	 index);
-
-CompBool
-forEachWindowObject (CompObject	        *parent,
-		     ObjectCallBackProc proc,
-		     void	        *closure);
-
-char *
-nameWindowObject (CompObject *object);
-
-CompObject *
-findWindowObject (CompObject *parent,
-		  const char *name);
-
-int
-allocateWindowPrivateIndex (CompScreen *screen);
-
-void
-freeWindowPrivateIndex (CompScreen *screen,
-			int	   index);
-
-unsigned int
-windowStateMask (CompDisplay *display,
-		 Atom	     state);
-
-unsigned int
-windowStateFromString (const char *str);
-
-unsigned int
-getWindowState (CompDisplay *display,
-		Window      id);
-
-void
-setWindowState (CompDisplay  *display,
-		unsigned int state,
-		Window       id);
-
-void
-changeWindowState (CompWindow   *w,
-		   unsigned int newState);
-
-void
-recalcWindowActions (CompWindow *w);
-
-unsigned int
-constrainWindowState (unsigned int state,
-		      unsigned int actions);
-
-unsigned int
-windowTypeFromString (const char *str);
-
-unsigned int
-getWindowType (CompDisplay *display,
-	       Window      id);
-
-void
-recalcWindowType (CompWindow *w);
-
-void
-getMwmHints (CompDisplay  *display,
-	     Window	  id,
-	     unsigned int *func,
-	     unsigned int *decor);
-
-unsigned int
-getProtocols (CompDisplay *display,
-	      Window      id);
-
-unsigned int
-getWindowProp (CompDisplay  *display,
-	       Window	    id,
-	       Atom	    property,
-	       unsigned int defaultValue);
-
-void
-setWindowProp (CompDisplay  *display,
-	       Window       id,
-	       Atom	    property,
-	       unsigned int value);
-
-Bool
-readWindowProp32 (CompDisplay    *display,
-		  Window	 id,
-		  Atom		 property,
-		  unsigned short *returnValue);
-
-unsigned short
-getWindowProp32 (CompDisplay	*display,
-		 Window		id,
-		 Atom		property,
-		 unsigned short defaultValue);
-
-void
-setWindowProp32 (CompDisplay    *display,
-		 Window         id,
-		 Atom		property,
-		 unsigned short value);
-
-void
-updateNormalHints (CompWindow *window);
-
-void
-updateWmHints (CompWindow *w);
-
-void
-updateWindowClassHints (CompWindow *window);
-
-void
-updateTransientHint (CompWindow *w);
-
-void
-updateIconGeometry (CompWindow *w);
-
-Window
-getClientLeader (CompWindow *w);
-
-char *
-getStartupId (CompWindow *w);
-
-int
-getWmState (CompDisplay *display,
-	    Window      id);
-
-void
-setWmState (CompDisplay *display,
-	    int		state,
-	    Window      id);
-
-void
-setWindowFrameExtents (CompWindow	 *w,
-		       CompWindowExtents *input);
-
-void
-updateWindowOutputExtents (CompWindow *w);
-
-void
-updateWindowRegion (CompWindow *w);
-
-Bool
-updateWindowStruts (CompWindow *w);
-
-void
-addWindow (CompScreen *screen,
-	   Window     id,
-	   Window     aboveId);
-
-void
-removeWindow (CompWindow *w);
-
-void
-destroyWindow (CompWindow *w);
-
-void
-sendConfigureNotify (CompWindow *w);
-
-void
-mapWindow (CompWindow *w);
-
-void
-unmapWindow (CompWindow *w);
-
-Bool
-bindWindow (CompWindow *w);
-
-void
-releaseWindow (CompWindow *w);
-
-void
-moveWindow (CompWindow *w,
-	    int        dx,
-	    int        dy,
-	    Bool       damage,
-	    Bool       immediate);
-
-void
-configureXWindow (CompWindow	 *w,
-		  unsigned int	 valueMask,
-		  XWindowChanges *xwc);
-
-unsigned int
-adjustConfigureRequestForGravity (CompWindow     *w,
-				  XWindowChanges *xwc,
-				  unsigned int   xwcm,
-				  int            gravity);
-
-void
-moveResizeWindow (CompWindow     *w,
-		  XWindowChanges *xwc,
-		  unsigned int   xwcm,
-		  int            gravity,
-		  unsigned int   source);
-
-void
-syncWindowPosition (CompWindow *w);
-
-void
-sendSyncRequest (CompWindow *w);
-
-Bool
-resizeWindow (CompWindow *w,
-	      int	 x,
-	      int	 y,
-	      int	 width,
-	      int	 height,
-	      int	 borderWidth);
-
-void
-configureWindow (CompWindow	 *w,
-		 XConfigureEvent *ce);
-
-void
-circulateWindow (CompWindow	 *w,
-		 XCirculateEvent *ce);
-
-void
-addWindowDamageRect (CompWindow *w,
-		     BoxPtr     rect);
-
-void
-getOutputExtentsForWindow (CompWindow	     *w,
-			   CompWindowExtents *output);
-
-void
-getAllowedActionsForWindow (CompWindow   *w,
-			    unsigned int *setActions,
-			    unsigned int *clearActions);
-
-void
-addWindowDamage (CompWindow *w);
-
-void
-damageWindowOutputExtents (CompWindow *w);
-
-Bool
-damageWindowRect (CompWindow *w,
-		  Bool       initial,
-		  BoxPtr     rect);
-
-void
-damageTransformedWindowRect (CompWindow *w,
-			     float	xScale,
-			     float	yScale,
-			     float	xTranslate,
-			     float	yTranslate,
-			     BoxPtr     rect);
-
-Bool
-focusWindow (CompWindow *w);
-
-Bool
-placeWindow (CompWindow *w,
-	     int        x,
-	     int        y,
-	     int        *newX,
-	     int        *newY);
-
-void
-validateWindowResizeRequest (CompWindow     *w,
-			     unsigned int   *mask,
-			     XWindowChanges *xwc,
-			     unsigned int   source);
-
-void
-windowResizeNotify (CompWindow *w,
-		    int	       dx,
-		    int	       dy,
-		    int	       dwidth,
-		    int	       dheight);
-
-void
-windowMoveNotify (CompWindow *w,
-		  int	     dx,
-		  int	     dy,
-		  Bool	     immediate);
-
-void
-windowGrabNotify (CompWindow   *w,
-		  int	       x,
-		  int	       y,
-		  unsigned int state,
-		  unsigned int mask);
-
-void
-windowUngrabNotify (CompWindow *w);
-
-void
-windowStateChangeNotify (CompWindow   *w,
-			 unsigned int lastState);
-
-void
-moveInputFocusToWindow (CompWindow *w);
-
-void
-updateWindowSize (CompWindow *w);
-
-void
-raiseWindow (CompWindow *w);
-
-void
-lowerWindow (CompWindow *w);
-
-void
-restackWindowAbove (CompWindow *w,
-		    CompWindow *sibling);
-
-void
-restackWindowBelow (CompWindow *w,
-		    CompWindow *sibling);
-
-void
-updateWindowAttributes (CompWindow             *w,
-			CompStackingUpdateMode stackingMode);
-
-void
-activateWindow (CompWindow *w);
-
-void
-closeWindow (CompWindow *w,
-	     Time	serverTime);
-
-Bool
-constrainNewWindowSize (CompWindow *w,
-			int        width,
-			int        height,
-			int        *newWidth,
-			int        *newHeight);
-
-void
-hideWindow (CompWindow *w);
-
-void
-showWindow (CompWindow *w);
-
-void
-minimizeWindow (CompWindow *w);
-
-void
-unminimizeWindow (CompWindow *w);
-
-void
-maximizeWindow (CompWindow *w,
-		int	   state);
-
-Bool
-getWindowUserTime (CompWindow *w,
-		   Time       *time);
-
-void
-setWindowUserTime (CompWindow *w,
-		   Time       time);
-
-Bool
-allowWindowFocus (CompWindow   *w,
-		  unsigned int noFocusMask,
-		  unsigned int viewportX,
-		  unsigned int viewportY,
-		  Time         timestamp);
-
-void
-unredirectWindow (CompWindow *w);
-
-void
-redirectWindow (CompWindow *w);
-
-void
-defaultViewportForWindow (CompWindow *w,
-			  int	     *vx,
-			  int        *vy);
-
-CompIcon *
-getWindowIcon (CompWindow *w,
-	       int	  width,
-	       int	  height);
-
-void
-freeWindowIcons (CompWindow *w);
-
-int
-outputDeviceForWindow (CompWindow *w);
-
-Bool
-onCurrentDesktop (CompWindow *w);
-
-void
-setDesktopForWindow (CompWindow   *w,
-		     unsigned int desktop);
-
-int
-compareWindowActiveness (CompWindow *w1,
-			 CompWindow *w2);
-
-Bool
-windowOnAllViewports (CompWindow *w);
-
-void
-getWindowMovementForOffset (CompWindow *w,
-			    int        offX,
-			    int        offY,
-			    int        *retX,
-			    int        *retY);
-
 /* plugin.c */
 
 #define HOME_PLUGINDIR ".compiz/plugins"
diff --git a/include/decoration.h b/include/decoration.h
index 5eed043..9bc6552 100644
--- a/include/decoration.h
+++ b/include/decoration.h
@@ -196,19 +196,32 @@ decor_property_to_quads (long		 *data,
 			 decor_quad_t    *quad);
 
 void
+decor_region_to_box_property (long   *data,
+			      int    width,
+			      int    height,
+			      Region topRegion,
+			      int    topOffset,
+			      Region bottomRegion,
+			      int    bottomOffset,
+			      Region leftRegion,
+			      int    leftOffset,
+			      Region rightRegion,
+			      int    rightOffset);
+
+void
 decor_region_to_blur_property (long   *data,
 			       int    threshold,
 			       int    filter,
 			       int    width,
 			       int    height,
-			       Region topRegion,
-			       int    topOffset,
-			       Region bottomRegion,
-			       int    bottomOffset,
-			       Region leftRegion,
-			       int    leftOffset,
-			       Region rightRegion,
-			       int    rightOffset);
+			       Region top_region,
+			       int    top_offset,
+			       Region bottom_region,
+			       int    bottom_offset,
+			       Region left_region,
+			       int    left_offset,
+			       Region right_region,
+			       int    right_offset);
 
 void
 decor_apply_gravity (int gravity,
diff --git a/kde/window-decorator-kde4/decorator.cpp b/kde/window-decorator-kde4/decorator.cpp
index 96b818d..6ca2a39 100644
--- a/kde/window-decorator-kde4/decorator.cpp
+++ b/kde/window-decorator-kde4/decorator.cpp
@@ -403,7 +403,7 @@ KWD::Decorator::updateShadow (void)
 	KWD::trapXError ();
 	XChangeProperty (QX11Info::display(), QX11Info::appRootWindow(),
 			 Atoms::netWindowDecorBare,
-			 XA_INTEGER,
+			 Atoms::netWindowDecor,
 			 32, PropModeReplace, (unsigned char *) data,
 			 BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
 	KWD::popXError ();
diff --git a/kde/window-decorator-kde4/switcher.cpp b/kde/window-decorator-kde4/switcher.cpp
index 2978e69..860b8aa 100644
--- a/kde/window-decorator-kde4/switcher.cpp
+++ b/kde/window-decorator-kde4/switcher.cpp
@@ -261,15 +261,18 @@ KWD::Switcher::updateBlurProperty (int topOffset,
 
     if (size)
     {
-	long data[size * 6 + 2];
-
-	decor_region_to_blur_property (data, 4, 0,
-				       mGeometry.width (),
-				       mGeometry.height (),
-				       topRegion, topOffset,
-				       bottomRegion, bottomOffset,
-				       leftRegion, leftOffset,
-				       rightRegion, rightOffset);
+      	long data[size * 6 + 2];
+
+        data[0] = 4;
+	data[1] = 0;
+
+	decor_region_to_box_property (data + 2,
+                                      mGeometry.width (),
+                                      mGeometry.height (),
+                                      topRegion, topOffset,
+                                      bottomRegion, bottomOffset,
+                                      leftRegion, leftOffset,
+                                      rightRegion, rightOffset);
 
 	KWD::trapXError ();
 	XChangeProperty (QX11Info::display (), mId, atom, XA_INTEGER,
diff --git a/kde/window-decorator-kde4/window.cpp b/kde/window-decorator-kde4/window.cpp
index d2d362b..1e7d8c5 100644
--- a/kde/window-decorator-kde4/window.cpp
+++ b/kde/window-decorator-kde4/window.cpp
@@ -1426,13 +1426,16 @@ KWD::Window::updateBlurProperty (int topOffset,
     {
 	long data[size * 6 + 2];
 
-	decor_region_to_blur_property (data, 4, 0,
-				       mGeometry.width (),
-				       mGeometry.height (),
-				       topRegion, topOffset,
-				       bottomRegion, bottomOffset,
-				       leftRegion, leftOffset,
-				       rightRegion, rightOffset);
+        data[0] = 4;
+	data[1] = 0;
+
+	decor_region_to_box_property (data + 2,
+                                      mGeometry.width (),
+                                      mGeometry.height (),
+                                      topRegion, topOffset,
+                                      bottomRegion, bottomOffset,
+                                      leftRegion, leftOffset,
+                                      rightRegion, rightOffset);
 
 	KWD::trapXError ();
 	XChangeProperty (QX11Info::display(), mClientId, atom,
@@ -1542,7 +1545,7 @@ KWD::Window::updateProperty (void)
 
     KWD::trapXError ();
     XChangeProperty (QX11Info::display(), mClientId, atom,
-		     XA_INTEGER,
+		     Atoms::netWindowDecor,
 		     32, PropModeReplace, (unsigned char *) data,
 		     BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
     KWD::popXError ();
diff --git a/kde/window-decorator/decorator.cpp b/kde/window-decorator/decorator.cpp
index 2d5ada0..03819dc 100644
--- a/kde/window-decorator/decorator.cpp
+++ b/kde/window-decorator/decorator.cpp
@@ -530,7 +530,7 @@ KWD::Decorator::updateShadow (void)
 	KWD::trapXError ();
 	XChangeProperty (qt_xdisplay (), qt_xrootwin (),
 			 Atoms::netWindowDecorBare,
-			 XA_INTEGER,
+			 Atoms::netWindowDecor,
 			 32, PropModeReplace, (unsigned char *) data,
 			 BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
 	KWD::popXError ();
diff --git a/kde/window-decorator/window.cpp b/kde/window-decorator/window.cpp
index 55580e6..9e73e1a 100644
--- a/kde/window-decorator/window.cpp
+++ b/kde/window-decorator/window.cpp
@@ -1323,13 +1323,16 @@ KWD::Window::updateBlurProperty (int topOffset,
     {
 	long data[size * 6 + 2];
 
-	decor_region_to_blur_property (data, 4, 0,
-				       mGeometry.width (),
-				       mGeometry.height (),
-				       topRegion, topOffset,
-				       bottomRegion, bottomOffset,
-				       leftRegion, leftOffset,
-				       rightRegion, rightOffset);
+        data[0] = 4;
+	data[1] = 0;
+
+	decor_region_to_box_property (data + 2,
+                                      mGeometry.width (),
+                                      mGeometry.height (),
+                                      topRegion, topOffset,
+                                      bottomRegion, bottomOffset,
+                                      leftRegion, leftOffset,
+                                      rightRegion, rightOffset);
 
 	KWD::trapXError ();
 	XChangeProperty (qt_xdisplay (), mClientId, atom,
@@ -1442,7 +1445,7 @@ KWD::Window::updateProperty (void)
 
     KWD::trapXError ();
     XChangeProperty (qt_xdisplay (), mClientId, atom,
-		     XA_INTEGER,
+		     Atoms::netWindowDecor,
 		     32, PropModeReplace, (unsigned char *) data,
 		     BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
     KWD::popXError ();
diff --git a/libdecoration/decoration.c b/libdecoration/decoration.c
index 1f3407c..b261045 100644
--- a/libdecoration/decoration.c
+++ b/libdecoration/decoration.c
@@ -205,13 +205,13 @@ decor_property_to_quads (long		 *data,
 }
 
 static int
-add_blur_boxes (long   *data,
-		BoxPtr box,
-		int    n_box,
-		int    width,
-		int    height,
-		int    gravity,
-		int    offset)
+add_boxes (long   *data,
+	   BoxPtr box,
+	   int    n_box,
+	   int    width,
+	   int    height,
+	   int    gravity,
+	   int    offset)
 {
     int x1, y1, x2, y2;
     int more_gravity;
@@ -289,6 +289,52 @@ add_blur_boxes (long   *data,
 }
 
 void
+decor_region_to_box_property (long   *data,
+			      int    width,
+			      int    height,
+			      Region top_region,
+			      int    top_offset,
+			      Region bottom_region,
+			      int    bottom_offset,
+			      Region left_region,
+			      int    left_offset,
+			      Region right_region,
+			      int    right_offset)
+{
+    if (top_region)
+	data += add_boxes (data,
+			   top_region->rects,
+			   top_region->numRects,
+			   width, height,
+			   GRAVITY_NORTH,
+			   top_offset);
+
+    if (bottom_region)
+	data += add_boxes (data,
+			   bottom_region->rects,
+			   bottom_region->numRects,
+			   width, height,
+			   GRAVITY_SOUTH,
+			   bottom_offset);
+
+    if (left_region)
+	data += add_boxes (data,
+			   left_region->rects,
+			   left_region->numRects,
+			   width, height,
+			   GRAVITY_WEST,
+			   left_offset);
+
+    if (right_region)
+	data += add_boxes (data,
+			   right_region->rects,
+			   right_region->numRects,
+			   width, height,
+			   GRAVITY_EAST,
+			   right_offset);
+}
+
+void
 decor_region_to_blur_property (long   *data,
 			       int    threshold,
 			       int    filter,
@@ -303,40 +349,14 @@ decor_region_to_blur_property (long   *data,
 			       Region right_region,
 			       int    right_offset)
 {
-    *data++ = threshold;
-    *data++ = filter;
-
-    if (top_region)
-	data += add_blur_boxes (data,
-				top_region->rects,
-				top_region->numRects,
-				width, height,
-				GRAVITY_NORTH,
-				top_offset);
-
-    if (bottom_region)
-	data += add_blur_boxes (data,
-				bottom_region->rects,
-				bottom_region->numRects,
-				width, height,
-				GRAVITY_SOUTH,
-				bottom_offset);
-
-    if (left_region)
-	data += add_blur_boxes (data,
-				left_region->rects,
-				left_region->numRects,
-				width, height,
-				GRAVITY_WEST,
-				left_offset);
-
-    if (right_region)
-	data += add_blur_boxes (data,
-				right_region->rects,
-				right_region->numRects,
-				width, height,
-				GRAVITY_EAST,
-				right_offset);
+    data[0] = threshold;
+    data[1] = filter;
+
+    decor_region_to_box_property (data + 2, width, height,
+				  top_region, top_offset,
+				  bottom_region, bottom_offset,
+				  left_region, left_offset,
+				  right_region, right_offset);
 }
 
 void
diff --git a/metadata/Makefile.am b/metadata/Makefile.am
index 666d989..eeb208a 100644
--- a/metadata/Makefile.am
+++ b/metadata/Makefile.am
@@ -11,6 +11,7 @@ xml_in_files =		  \
 	fs.xml.in	  \
 	gconf.xml.in	  \
 	glib.xml.in	  \
+	glx.xml.in	  \
 	ini.xml.in	  \
 	inotify.xml.in	  \
 	kconfig.xml.in	  \
@@ -28,6 +29,7 @@ xml_in_files =		  \
 	switcher.xml.in   \
 	video.xml.in      \
 	water.xml.in      \
+	wm.xml.in	  \
 	wobbly.xml.in     \
 	zoom.xml.in
 xml_files    = $(xml_in_files:.xml.in=.xml)
diff --git a/metadata/annotate.xml.in b/metadata/annotate.xml.in
index 46a2b09..486b84a 100644
--- a/metadata/annotate.xml.in
+++ b/metadata/annotate.xml.in
@@ -2,6 +2,14 @@
     <plugin name="annotate">
 	<_short>Annotate</_short>
 	<_long>Annotate plugin</_long>
+	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
+	    <relation type="after">
+		<plugin>glx</plugin>
+	    </relation>
+	</deps>
 	<display>
 	    <option name="initiate_button" type="button">
 		<_short>Initiate</_short>
diff --git a/metadata/blur.xml.in b/metadata/blur.xml.in
index 21be0f0..1fd674f 100644
--- a/metadata/blur.xml.in
+++ b/metadata/blur.xml.in
@@ -4,6 +4,9 @@
 	<_long>Blur windows</_long>
 	<feature>blur</feature>
 	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
 	    <relation type="before">
 		<plugin>video</plugin>
 	    </relation>
diff --git a/metadata/clone.xml.in b/metadata/clone.xml.in
index d7c7ce4..7735f7c 100644
--- a/metadata/clone.xml.in
+++ b/metadata/clone.xml.in
@@ -2,6 +2,11 @@
     <plugin name="clone">
 	<_short>Clone Output</_short>
 	<_long>Output clone handler</_long>
+	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
+	</deps>
 	<display>
 	    <option name="initiate_button" type="button">
 		<_short>Initiate</_short>
diff --git a/metadata/cube.xml.in b/metadata/cube.xml.in
index f07da8b..ff9b114 100644
--- a/metadata/cube.xml.in
+++ b/metadata/cube.xml.in
@@ -4,6 +4,9 @@
 	<_long>Place windows on cube</_long>
 	<feature>largedesktop</feature>
 	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
 	    <relation type="before">
 		<plugin>switcher</plugin>
 		<plugin>scale</plugin>
diff --git a/metadata/fade.xml.in b/metadata/fade.xml.in
index 7e1ddff..a327e1e 100644
--- a/metadata/fade.xml.in
+++ b/metadata/fade.xml.in
@@ -3,6 +3,9 @@
 	<_short>Fading Windows</_short>
 	<_long>Fade in windows when mapped and fade out windows when unmapped</_long>
 	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
 	    <relation type="before">
 		<plugin>cube</plugin>
 		<plugin>scale</plugin>
diff --git a/metadata/glx.xml.in b/metadata/glx.xml.in
new file mode 100644
index 0000000..9f25dcd
--- /dev/null
+++ b/metadata/glx.xml.in
@@ -0,0 +1,9 @@
+<compiz>
+    <plugin name="glx">
+	<_short>GLX</_short>
+	<_long>GLX compositing output</_long>
+	<display>
+	    <option name="abi" type="int" read_only="true"/>
+	</display>
+    </plugin>
+</compiz>
\ No newline at end of file
diff --git a/metadata/minimize.xml.in b/metadata/minimize.xml.in
index 4968549..f9e8077 100644
--- a/metadata/minimize.xml.in
+++ b/metadata/minimize.xml.in
@@ -4,6 +4,9 @@
 	<_long>Transform windows when they are minimized and unminimized</_long>
 	<feature>windowanimations</feature>
 	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
 	    <relation type="before">
 		<plugin>cube</plugin>
 		<plugin>scale</plugin>
diff --git a/metadata/place.xml.in b/metadata/place.xml.in
index 19625ba..fd9b524 100644
--- a/metadata/place.xml.in
+++ b/metadata/place.xml.in
@@ -2,6 +2,11 @@
     <plugin name="place">
 	<_short>Place Windows</_short>
 	<_long>Place windows at appropriate positions when mapped</_long>
+	<deps>
+	    <requirement>
+		<plugin>wm</plugin>
+	    </requirement>
+	</deps>
 	<screen>
 	    <option name="workarounds" type="bool">
 		<_short>Workarounds</_short>
diff --git a/metadata/scale.xml.in b/metadata/scale.xml.in
index c551aa3..f85132c 100644
--- a/metadata/scale.xml.in
+++ b/metadata/scale.xml.in
@@ -2,6 +2,11 @@
     <plugin name="scale">
 	<_short>Scale</_short>
 	<_long>Scale windows</_long>
+	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
+	</deps>
 	<display>
 	    <option name="abi" type="int" read_only="true"/>
 	    <option name="index" type="int" read_only="true"/>
diff --git a/metadata/screenshot.xml.in b/metadata/screenshot.xml.in
index d7b528e..8de85e7 100644
--- a/metadata/screenshot.xml.in
+++ b/metadata/screenshot.xml.in
@@ -2,6 +2,11 @@
     <plugin name="screenshot">
 	<_short>Screenshot</_short>
 	<_long>Screenshot plugin</_long>
+	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
+	</deps>
 	<display>
 	    <option name="initiate_button" type="button">
 		<_short>Initiate</_short>
diff --git a/metadata/svg.xml.in b/metadata/svg.xml.in
index 7eaa8b8..eaa0293 100644
--- a/metadata/svg.xml.in
+++ b/metadata/svg.xml.in
@@ -4,5 +4,10 @@
 	<_long>Svg image loader</_long>
 	<feature>imageext:svg</feature>
 	<feature>imagemime:image/svg+xml</feature>
+	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
+	</deps>
     </plugin>
 </compiz>
diff --git a/metadata/switcher.xml.in b/metadata/switcher.xml.in
index e829cc3..03c01e5 100644
--- a/metadata/switcher.xml.in
+++ b/metadata/switcher.xml.in
@@ -2,6 +2,11 @@
     <plugin name="switcher">
 	<_short>Application Switcher</_short>
 	<_long>Application Switcher</_long>
+	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
+	</deps>
 	<display>
 	    <option name="next_button" type="button">
 		<_short>Next window</_short>
diff --git a/metadata/video.xml.in b/metadata/video.xml.in
index 09c5076..1a7cedc 100644
--- a/metadata/video.xml.in
+++ b/metadata/video.xml.in
@@ -3,6 +3,11 @@
 	<_short>Video Playback</_short>
 	<_long>Video playback</_long>
 	<feature>video</feature>
+	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
+	</deps>
 	<display>
 	    <option name="yv12" type="bool">
 		<_short>YV12 colorspace</_short>
diff --git a/metadata/water.xml.in b/metadata/water.xml.in
index 9d3b9d2..4ea35a1 100644
--- a/metadata/water.xml.in
+++ b/metadata/water.xml.in
@@ -3,6 +3,9 @@
 	<_short>Water Effect</_short>
 	<_long>Adds water effects to different desktop actions</_long>
 	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
 	    <relation type="before">
 		<plugin>blur</plugin>
 		<plugin>video</plugin>
diff --git a/metadata/wm.xml.in b/metadata/wm.xml.in
new file mode 100644
index 0000000..5c5a023
--- /dev/null
+++ b/metadata/wm.xml.in
@@ -0,0 +1,9 @@
+<compiz>
+    <plugin name="wm">
+	<_short>Window Management</_short>
+	<_long>Window management</_long>
+	<display>
+	    <option name="abi" type="int" read_only="true"/>
+	</display>
+    </plugin>
+</compiz>
diff --git a/metadata/wobbly.xml.in b/metadata/wobbly.xml.in
index 005ef3d..c2fb951 100644
--- a/metadata/wobbly.xml.in
+++ b/metadata/wobbly.xml.in
@@ -3,6 +3,9 @@
 	<_short>Wobbly Windows</_short>
 	<_long>Use spring model for wobbly window effect</_long>
 	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
 	    <relation type="before">
 		<plugin>fade</plugin>
 		<plugin>cube</plugin>
diff --git a/metadata/zoom.xml.in b/metadata/zoom.xml.in
index 1a5bd5b..6903c5e 100644
--- a/metadata/zoom.xml.in
+++ b/metadata/zoom.xml.in
@@ -2,6 +2,11 @@
     <plugin name="zoom">
 	<_short>Zoom Desktop</_short>
 	<_long>Zoom and pan desktop cube</_long>
+	<deps>
+	    <requirement>
+		<plugin>glx</plugin>
+	    </requirement>
+	</deps>
 	<display>
 	    <option name="initiate_button" type="button">
 		<_short>Initiate</_short>
diff --git a/plugins/Makefile.am b/plugins/Makefile.am
index 66e4ed7..7e1129d 100644
--- a/plugins/Makefile.am
+++ b/plugins/Makefile.am
@@ -1,3 +1,9 @@
+libwm_la_LDFLAGS = -module -avoid-version -no-undefined
+libwm_la_SOURCES = wm.c
+
+libglx_la_LDFLAGS = -module -avoid-version -no-undefined
+libglx_la_SOURCES = glx.c
+
 libfade_la_LDFLAGS = -module -avoid-version -no-undefined
 libfade_la_SOURCES = fade.c
 
@@ -19,7 +25,9 @@ libwobbly_la_SOURCES = wobbly.c
 libminimize_la_LDFLAGS = -module -avoid-version -no-undefined
 libminimize_la_SOURCES = minimize.c
 
+libmove_la_DEPENDENCIES = $(top_builddir)/libdecoration/libdecoration.la
 libmove_la_LDFLAGS = -module -avoid-version -no-undefined
+libmove_la_LIBADD = $(top_builddir)/libdecoration/libdecoration.la
 libmove_la_SOURCES = move.c
 
 libresize_la_LDFLAGS = -module -avoid-version -no-undefined
@@ -148,6 +156,8 @@ INCLUDES =					\
 moduledir = $(plugindir)
 
 module_LTLIBRARIES =		\
+	libwm.la		\
+	libglx.la		\
 	$(libglib_module)	\
 	$(libgconf_module)	\
 	$(libkconfig_module)	\
diff --git a/plugins/annotate.c b/plugins/annotate.c
index 6271260..e671468 100644
--- a/plugins/annotate.c
+++ b/plugins/annotate.c
@@ -118,7 +118,7 @@ annoCairoContext (CompScreen *s)
 	format = XRenderFindStandardFormat (s->display->display,
 					    PictStandardARGB32);
 
-	as->pixmap = XCreatePixmap (s->display->display, s->root, w, h, 32);
+	as->pixmap = XCreatePixmap (s->display->display, s->root.id, w, h, 32);
 
 	if (!bindPixmapToTexture (s, &as->texture, as->pixmap, w, h, 32))
 	{
@@ -497,7 +497,7 @@ annoTerminate (CompDisplay     *d,
     {
 	ANNO_SCREEN (s);
 
-	if (xid && s->root != xid)
+	if (xid && s->root.id != xid)
 	    continue;
 
 	if (as->grabIndex)
@@ -758,7 +758,8 @@ annoInitDisplay (CompPlugin  *p,
 {
     AnnoDisplay *ad;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     ad = malloc (sizeof (AnnoDisplay));
